Subject: PMP> add device in host resource/mib

From: Jörg Geistmann <[email-masked]>
Date: Wed, 20 Aug 2003 16:47:24 +0200

hello experts! :-)

i am a newbie here ... a question now!

we want to built our own printer mib under windows!
now we need a additional device (printer) in the host
resource/mib.
know anybody here in which way we can do this in windows?

is this the right place here?
or where can i find this information?

many thanx for any help,
jörg

Dipl.-Ing. Jörg Geistmann (mailto:[email-masked])
Team Leader Software Development

RATIO Entwicklungen GmbH
Admiralitaetstrasse 59
D-20459 Hamburg

Phone: +49-40-369007-23
Fax:   +49-40-369007-75

---

From: [email-masked]
Date: Fri, 22 Aug 2003 07:45:05 -0700

Hi Jörg,

The answers to your questions depend upon the agent implementation
you are using.  If you do not have a developer's guide, the source 
code, or an SDK, you should contact the vendor of the code.  

	Ron Bergman
	Hitachi Printing Solutions America

-----Original Message-----
From: Jörg Geistmann [mailto:[email-masked]]
Sent: Friday, August 22, 2003 2:24 AM
To: [email-masked]
Cc: [email-masked]
Subject: AW: PMP> add device in host resource/mib

> Hi Jörg,
hi ron!

many thanx for your reply!

> The agent code provides the interface protocol between the external
> SNMP managers and the MIB.  The MIB defines a data base of managed
> information relative to a device, software module, or any other
> entity to be managed.  A MIB implementation defines the rules or
> procedures necessary to obtain or modify the entries (objects) in
> the data base.
yes i know!

> You need to use the SNMP agent already installed in Windows and
> integrate the printer MIB into that code.  The details of this
> integration are very specific to the design of the agent.
i know it!

> The value of hrDeviceIndex for the printer MIB instance corresponding
> to your plotter can be any value desired, as long as it is unique
> (i.e. does not conflict with any of the existing assignments).
yes, i know this unique hrDeviceIndex is handeld from the sub agent
hostmib (hostmib.dll) from the windows system.
this sub agent create this hrDeviceIndex for me in an unknow way.

if we develop a sub agent printmib for our plotter/software we need this
unique hrDeviceIndex in the printermib for the tableindex(es).

our problem is what must we do that the subagent hostmib create for us this
hrDeviceIndex.
- must we install a dummy printerdriver? then the sub agent host mib
create a unique hrDeviceIndex for this printer and we use this index.
(this works but is this the way?)

- or must we develop a own hostmib agent (we dont want because then we must
handle other devices like networkcard, memory, ports, ... too)

we have an other problem because of the staties in the hostmib.
in our subagent printermib we can set the staties for our plotter/software
but there are 3 plotterstaties in the hostmib too:
- hrDeviceStatus (unknown(1), running(2), warning(3), testing(4),  down(5))
- hrPrinterStatus {other(1), unknown(2), idle(3), printing(4), warmup(5)}
- hrPrinterDetectedErrorState (lowPaper, noPaper, lowToner, noToner,
doorOpen, jammed, offline, serviceRequested)
from which location get the subagent (hostmib) the infos for the staties?
(from the printerdriver?)
what must we do that the subagent (hostmib) do for us the job?
(or must we develop a subagent for the hrPrinterTable in the hostmib?)

i hope you habe any idea!

all the best,
jörg geistmann

> > Hi Jörg,
> good morning ron!
>
> > I guess that the SNMP agent in Windows was purchased and the
> > HR MIB supports the computer and possibly other devices in the
> > computer.  Is this correct?
> yes, the HR MIB is supportet from the Windows SNMP Service about the
> windows agent hostmib.dll. This agent/dll create the mib tree,
> for example:
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.1 = 1
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.2 = 2
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.3 = 3
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.4 = 4
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.5 = 5
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.6 = 6
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.7 = 7
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.8 = 8
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.9 = 9
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.10 = 10
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceType.1 = OID:
> host.hrDevice.hrDeviceTypes.hrDevicePrinter
> ...
>
> > Have you also included the Printer MIB in the system by adding
> > another DLL
> no there is no other printer MIB in the system (i think that can exist
> only one!) we want to develop our own printer mib dll.
>
> > and using the existing SNMP agent?
> yes we want to use the existing SNMP HOSTMIB agent dll.
>
> > Have you assigned a unique hrDeviceIndex to the printer (i.e.
> > plotter) in your Printer MIB?
> this ist exactly the problem! we need a unique hrDeviceIndex in the
> Printer MIB. And this unique Index comming from the Host Mib, isn´t it?
>
> i think we must install our "printer" IN A WAY(?) that the SNMP HOSTMIB
> agent dll identify this as a printer. and create for us the unique
> hrDeviceIndex. in our example case:
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceIndex.11 = 11
> ...
> host.hrDevice.hrDeviceTable.hrDeviceEntry.hrDeviceType.11 = OID:
> host.hrDevice.hrDeviceTypes.hrDevicePrinter
> :-)
>
> how can we do that the SNMP HOSTMIB agent dll work for us? :-)
>
> i am very interested in your answer!
>
> all the best
>
> jörg geistmann
>
>
>
>
>